
//This eXtension was copied from the shipped Extension_axCheckBox.js since the implementation of an inputbox is similar to that of a checkbox
function DEFINE_EXTENSION_axInputboxStyle1 ()
{
    var axInputboxStyleList = [ {
        value: "color",
        text: TEXT.dev( "axInputboxStyle1.inputType.color" )
    }, {
        value: "text",
        text: TEXT.dev( "axInputboxStyle1.inputType.text" )
    }, {
        value: "password",
        text: TEXT.dev( "axInputboxStyle1.inputType.password" )
    }, {
        value: "file",
        text: TEXT.dev( "axInputboxStyle1.inputType.file" )
    }, {
        value: "email",
        text: TEXT.dev( "axInputboxStyle1.inputType.email" )
    }, {
        value: "number",
        text: TEXT.dev( "axInputboxStyle1.inputType.number" )
    }];

    var definition_InputboxStyle1  =
    {
        name   : "InputboxStyle1",
        group  : "vis",
        type   : "element",
        display: TEXT.dev( "axInputboxStyle1.display" ),

        properties:
        {
            value: { 
                type: "String", 
                description: TEXT.dev( "axInputboxStyle1.value" )
            },
            style: {
                type: "Style", 
                description: TEXT.dev( "axInputboxStyle1.style" )
            },
            selectContentOnFocus: { 
                type: "Boolean", 
                defaultStatic: true, 
                description: TEXT.dev( "axInputboxStyle1.selectContentOnFocus" )
            },
            inputType: { 
                type: "String", 
                defaultStatic: "default",
                items: axInputboxStyleList,
                description: TEXT.dev( "axInputboxStyle1.inputType" )
            },
            onChange: { 
                type: "Event", 
                description: TEXT.dev( "axInputboxStyle1.onChange" ),
                defaultDynamic: "" 
            },
            onFocus: { 
                type: "Event", 
                description: TEXT.dev( "axInputboxStyle1.onFocus" ), 
                defaultDynamic: "" 
            },
            onBlur: { 
                type: "Event", 
                description: TEXT.dev( "axInputboxStyle1.onBlur" ), 
                defaultDynamic: "" 
            }
        },

        init: function( field, fieldDiv )
        {
            this._field = field;
            this._fieldDiv = fieldDiv;
            
            var inputbox, $inputbox;
            $inputbox = $( inputbox = this._content = document.createElement( "input" ) );                        	    
	    
            if ( !this.isDesignMode() )
            {
                if ( field.isInput )
                {
                    $inputbox.bind( "change", this, this._onChangePrivate );
                    $inputbox.bind( "input", this, this._onChangePrivate );
                    $inputbox.bind( "focus", this, this._onFocusPrivate );
                    $inputbox.bind( "blur", this, this._onBlurPrivate );
                } 
                else $inputbox.disabled = true;
            }

            var typePassword = this.getPropertyValue( "password" );
            if ( "password" == this.getPropertyValue( "inputType" ) )
                $( inputbox ).attr( 'type', 'password' );

            fieldDiv.appendChild( inputbox );
            this.applyTabIndex(inputbox, true);
            
            /* Listen for changes in the field value */
            field.addListener("SetFocus", this.setFocus, this);
            field.addListener( "ValueChanged", this._onFieldValueChanged, this );
        },

        /* Render this control onto the screen */
        render: function( field, fieldDiv )
        {
            var self = this;

            //size stores the "saved" size of the element
            var size = field.getSize();

            //For some reason, the Inputbox will, by default, will be positioned 1px higher than expected (i.e. top) and 1px taller than expected (i.e. height).  Therefore, we will compensate for this by 
            // moving the Inputbox 1px lower, and 1px shorter, than it is by default, relative to its div container.
            // set the size of the element to occupy the whole fieldDiv container
            var baseStyle =
            {
                width: size.width,
                height: size.height - 1
            };

            var style = this.getPropertyValue( "style" );
            this.applyStyle( style, self._content, baseStyle );

            var value = this.getPropertyValue( "value" );
            if ( "" == value )
                value = field.getValue();

            //Set the value of this Inputbox to that of the value of the 5250 field or the value property of the eXtension (if the designer set it)
            self._content.setAttribute( "value", value );
        },

        /* Clean up */
        destroy: function( field, fieldDiv )
        {
	    /* Remove any listeners */
            field.removeListener( "ValueChanged", this._onFieldValueChanged );
            field.removeListener( "SetFocus", this.setFocus );
            this._content = null;
            this._field = null;
            this._fieldDiv = null;
        },
                
        _onChangePrivate: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() )
                return;
            
            //I do not understand what the self._noFieldValueChangedEvent is, but it was used in the checkbox eXtension, in this context, so I have added it here.
            self._noFieldValueChangedEvent = true;
            self._field.setValue( self._content.value );
            self.raiseEvent( "onChange" );
        },
        
        _onFocusPrivate: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() )
                return;
		      
            if ( AXES.isTS2Engine )
            {
                if ( self.getPropertyValue( "selectContentOnFocus" ) )
                self._content.select();
            }
            else
            {
                if ( self._field.getProperty( "selectContentOnFocus" ) )
                self._content.select();
            }            
            self.raiseEvent( "onFocus" );
        },
        
        _onBlurPrivate: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() )
                return;
            
            self.raiseEvent( "onBlur" );
        },
        
        /* Handles the change in field value.  For example, if a button script on the form does a FIELDS("ThisExtension").setValue("ABC"), we want this textbox to display "ABC".  This event handles that */
        _onFieldValueChanged: function( event )
        {
            var self = this;
            if ( !self._field._noFieldValueChangedEvent )
                self.render( self._field, self._fieldDiv );
            else
                delete self._noFieldValueChangedEvent;
        },
        
        setFocus: function(event)
        {
            // May not be able to set the focus if the field is invisible
            try
            {
                if (event.offset != undefined) {
                    this.offsetOnFocus = event.offset;
                }
                this._content.focus();
            }
            catch(e) {}
        }
    };

    /* Register the extension with AXES */
    AXES.Extensions.add(definition_InputboxStyle1 );
}

/* Self define this extension */
DEFINE_EXTENSION_axInputboxStyle1();
